"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const useLogTable_1 = require("./useLogTable");
describe('logAsTable', () => {
    beforeEach(() => {
        console.log = jest.fn();
        console.error = jest.fn();
        console.table = jest.fn();
    });
    it('logs a valid object with emojis as an array', () => {
        const testObj = { key1: 'value1', key2: 'value2' };
        const emojis = ['😀', '😃'];
        (0, useLogTable_1.logAsTable)(testObj, emojis);
        expect(console.table).toHaveBeenCalledWith(expect.anything());
    });
});
describe('log', () => {
    beforeEach(() => {
        console.log = jest.fn();
        console.error = jest.fn();
    });
    it('logs a valid object with emojis as an array', () => {
        const testObj = { key1: 'value1', key2: 'value2' };
        const emojis = ['😀', '😃'];
        (0, useLogTable_1.log)(testObj, emojis);
        expect(console.log).toHaveBeenCalledWith(expect.anything());
    });
});
